;colortable for screen lines        
colortable:
;blue
!fi 4, $03
!fi 8, $0e
!fi 8, $04
!fi 8, $0e
!fi 4, $03

;purple
;!fi 4, $07
;!fi 8, $0a
;!fi 8, $04
;!fi 8, $0a
;!fi 4, $07

;grey
;!fi 4, $0b
;!fi 8, $0c
;!fi 8, $0f
;!fi 8, $0c
;!fi 4, $0b

;purple
;!fi 4, $07
;!fi 8, $0a
;!fi 8, $04
;!fi 8, $0a
;!fi 4, $07

;green
;!fi 4, $05
;!fi 8, $03
;!fi 8, $0d
;!fi 8, $03
;!fi 4, $05


;offset for the colortable (repeats every 8th line)
colortable_offset:
!byte $03,$02,$01,$00,$07,$06,$05,$04

init_colors:
  ldx #$08
-
  jsr shift_colors
  dex
  bne -
  rts      
  
shift_colors:
  ldx #$07
  ldy colortable_offset+7
-
  lda colortable_offset-1,x
  sta colortable_offset,x 
  dex
  bne -
  sty colortable_offset 

  ldx #31
  ldy colortable+31
-
  lda colortable-1,x
  sta colortable,x 
  dex
  bne -
  sty colortable 
  
;  ldx shift_table
;  lda colortable,x
;  sta $d800+(2*40)+(0*8),x
;  sta $d800+(2*40)+(4*8),x
;  lda colortable+8,x
;  sta $d800+(2*40)+(1*8),x
;  lda colortable+16,x
;  sta $d800+(2*40)+(2*8),x
;  lda colortable+24,x
;  sta $d800+(2*40)+(3*8),x

  !for ROW = 1 TO 4
    ldx colortable_offset + ROW
    lda colortable,x
    sta $d800+40+((16+ROW)*40)+(2*8),x
    lda colortable+8,x
    sta $d800+40+((16+ROW)*40)+(3*8),x
    lda colortable+16,x
    sta $d800+40+((16+ROW)*40)+(0*8),x
    sta $d800+40+((16+ROW)*40)+(4*8),x
    lda colortable+24,x
    sta $d800+40+((16+ROW)*40)+(1*8),x
  !end  
  !for ROW = 5 TO 7
    ldx colortable_offset + ROW
    lda colortable,x
    sta $d800+40+((16+ROW)*40)+(2*8),x
    lda colortable+8,x
    sta $d800+40+((16+ROW)*40)+(3*8),x
    lda colortable+16,x
    sta $d800+40+((16+ROW)*40)+(0*8),x
    sta $d800+40+((16+ROW)*40)+(4*8),x
    lda colortable+24,x
    sta $d800+40+((16+ROW)*40)+(1*8),x
  !end  
  rts  