credit_chars0:
!byte $41,$22,$80,$0a,$00,$22,$00,$08
credit_chars1:
!byte $2e,$54,$e1,$4c,$92,$12,$4c,$a2
credit_chars2:
!byte $e3,$b6,$5d,$b6,$6b,$95,$9a,$75
credit_chars3:
!byte $df,$ff,$77,$9f,$6f,$6d,$9f,$77

colors:
!fill 4, $d3
!fill 4, $5d
!fill 4, $85
!fill 4, $68
!fill 4, $e6
!fill 4, $3e

colors_end:

;error
!fill 4, $00

current_user_counter
!byte $ff

credits_cycle:
  dec current_user_counter
  lda current_user_counter
  cmp #$00
  beq +
  rts 
+  
  lda #$01
  sta current_user_counter
  !for part = 0 to 7
    ldx credit_chars0+part

    lda credit_chars1+part
    sta credit_chars0+part

    lda credit_chars2+part
    sta credit_chars1+part

    lda credit_chars3+part
    sta credit_chars2+part

    stx credit_chars3+part
  !end
  
  ldy colors
  !for part = 0 to 23
    lda colors+part+1
    sta colors+part
  !end
  sty colors_end-1  
 
  rts
  
set_chars_speedcode:
;set_chars_speedcode:
;0
  !for part = 0 to 7
    lda credit_chars0+part
    sta $6730+part
    sta $6878+part
    sta $6ea0+part
    sta $6ec0+part
    sta $6fe8+part
    sta $7008+part
    sta $7130+part
    sta $7278+part
  !end
;1
  !for part = 0 to 7
    lda credit_chars1+part
    sta $6738+part
    sta $6860+part
    sta $6880+part
    sta $6d60+part
    sta $6d80+part
    sta $6ea8+part
    sta $6ec8+part
    sta $7138+part
    sta $7260+part
    sta $7280+part
  !end
;2
  !for part = 0 to 7
    lda credit_chars2+part
    sta $6720+part
    sta $6740+part
    sta $6868+part
    sta $6c20+part
    sta $6888+part
    sta $6c40+part
    sta $6d68+part
    sta $6d88+part
    sta $7120+part
    sta $7140+part
    sta $7268+part
    sta $7288+part
  !end
;3  
  !for part = 0 to 7
    lda credit_chars3+part
    sta $6728+part
    sta $6748+part
    sta $6870+part
    sta $6c28+part
    sta $6c48+part
    sta $6fe0+part
    sta $7000+part
    sta $7128+part
    sta $7148+part
    sta $7270+part
  !end

;set_chars_speedcode:
  lda colors + 2
  sta credits_screen+(5*40)+28
  
  lda colors + 3
  sta credits_screen+(5*40)+29
  
  lda colors + 4
  sta credits_screen+(5*40)+30 

  lda colors + 5
  sta credits_screen+(5*40)+31 

  lda colors + 6
  sta credits_screen+(5*40)+32  

  lda colors + 7
  sta credits_screen+(5*40)+33  
  
;-------------------------------  

  lda colors + 1
  sta credits_screen+(6*40)+28  

  lda colors + 2
  sta credits_screen+(6*40)+29 

  lda colors + 3
  sta credits_screen+(6*40)+30  

  lda colors + 4
  sta credits_screen+(6*40)+31  

  lda colors + 5
  sta credits_screen+(6*40)+32  

  lda colors + 6
  sta credits_screen+(6*40)+33  

;-------------------------------

  lda colors_end -2
  sta credits_screen+(9*40)+28  

  lda colors_end -1
  sta credits_screen+(9*40)+29 

  lda colors + 2
  sta credits_screen+(9*40)+32  

  lda colors + 3
  sta credits_screen+(9*40)+33  
  
;-------------------------------  

  lda colors_end -3
  sta credits_screen+(10*40)+28  

  lda colors_end -2
  sta credits_screen+(10*40)+29 

  lda colors + 1
  sta credits_screen+(10*40)+32  

  lda colors + 2
  sta credits_screen+(10*40)+33  
  
;------------------------------- 

  lda colors_end -4
  sta credits_screen+(11*40)+28  

  lda colors_end -3
  sta credits_screen+(11*40)+29 

  lda colors + 0
  sta credits_screen+(11*40)+32  

  lda colors + 1
  sta credits_screen+(11*40)+33  
  
;------------------------------- 

  lda colors_end -5
  sta credits_screen+(12*40)+28  

  lda colors_end -4
  sta credits_screen+(12*40)+29 
 
  lda colors_end -1
  sta credits_screen+(12*40)+32  
  
  lda colors + 0
  sta credits_screen+(12*40)+33  
  
;------------------------------- 

  lda colors_end -6
  sta credits_screen+(13*40)+28
  
  lda colors_end -5
  sta credits_screen+(13*40)+29

  lda colors_end -4
  sta credits_screen+(13*40)+30
  
  lda colors_end -3
  sta credits_screen+(13*40)+31

  lda colors_end -2
  sta credits_screen+(13*40)+32
  
  lda colors_end -1
  sta credits_screen+(13*40)+33  
  
;-------------------------------  

  lda colors_end -7
  sta credits_screen+(14*40)+28
  
  lda colors_end -6
  sta credits_screen+(14*40)+29

  lda colors_end -5
  sta credits_screen+(14*40)+30
  
  lda colors_end -4
  sta credits_screen+(14*40)+31
  
  lda colors_end -3
  sta credits_screen+(14*40)+32
  
  lda colors_end -2
  sta credits_screen+(14*40)+33    
;------------------------------- 
rts