;BANK
;$DD00 = %xxxxxx11 -> bank0: $0000-$3fff
;$DD00 = %xxxxxx10 -> bank1: $4000-$7fff
;$DD00 = %xxxxxx01 -> bank2: $8000-$bfff
;$DD00 = %xxxxxx00 -> bank3: $c000-$ffff

;CHARMEM
;$D018 = %xxxx000x -> charmem is at $0000
;$D018 = %xxxx001x -> charmem is at $0800
;$D018 = %xxxx010x -> charmem is at $1000
;$D018 = %xxxx011x -> charmem is at $1800
;$D018 = %xxxx100x -> charmem is at $2000
;$D018 = %xxxx101x -> charmem is at $2800
;$D018 = %xxxx110x -> charmem is at $3000
;$D018 = %xxxx111x -> charmem is at $3800

;SCREENMEM
;$D018 = %0000xxxx -> screenmem is at $0000
;$D018 = %0001xxxx -> screenmem is at $0400
;$D018 = %0010xxxx -> screenmem is at $0800
;$D018 = %0011xxxx -> screenmem is at $0c00
;$D018 = %0100xxxx -> screenmem is at $1000
;$D018 = %0101xxxx -> screenmem is at $1400
;$D018 = %0110xxxx -> screenmem is at $1800
;$D018 = %0111xxxx -> screenmem is at $1c00
;$D018 = %1000xxxx -> screenmem is at $2000
;$D018 = %1001xxxx -> screenmem is at $2400
;$D018 = %1010xxxx -> screenmem is at $2800
;$D018 = %1011xxxx -> screenmem is at $2c00
;$D018 = %1100xxxx -> screenmem is at $3000
;$D018 = %1101xxxx -> screenmem is at $3400
;$D018 = %1110xxxx -> screenmem is at $3800
;$D018 = %1111xxxx -> screenmem is at $3c00
  
!zone hires
  
show_hires
  ;jsr wait_border
  
  lda #%00000010;Move the VIC 16K block bank1: $4000-$7fff
  sta $dd00
  
  lda #$3b      ; bitmap mode
  sta $d011

  lda #$08      ; single-colour mode
  sta $d016
      
  lda #%01111000; screen at $1c00, bitmap at $2000
  sta $d018
  rts

.color_table:
!byte $cc, $0c, $89, $89, $0c, $0c, $0e

.color_table_1:
!byte $3c, $bc, $eb, $8b, $03, $01, $03

.current_counter
!byte $01

current_x
!byte #$00

reset_animation
  ldx #$00
  jsr .set_colors
  rts
  
force_animation:
  lda #$0e
  sta .current_counter
  lda #$df  
  sta current_user_counter
  lda #(.color_table_1-.color_table)
  sta current_x
  rts
  
animate_hires:
  dec .current_counter
  bne +
  lda #$00 
  sta .current_counter 
  sta current_x
  jmp .set_colors
+
  lda current_x
  jmp .set_colors
  
;animate_hires:
;  dec .current_counter
;  bne ++
;  lda #$00
;  sta .current_counter
;  lda .current_x
;  cmp #$00
;  bne +
;  lda #(.color_table_1-.color_table)
;  sta .current_x  
;  jmp .set_colors
;+ 
;  lda #$00
;  sta .current_x  
;  jmp .set_colors
;++
;  rts
  
.set_colors:
  ldx current_x
  
  lda .color_table,x
  sta credits_screen+$00CA ; x=2 y=5
  sta credits_screen+$00C9 ; x=1 y=5
  sta credits_screen+$00A1 ; x=1 y=4
  sta credits_screen+$00A0 ; x=0 y=4
  sta credits_screen+$0079 ; x=1 y=3
  sta credits_screen+$0050 ; x=0 y=2
  sta credits_screen+$0001 ; x=1 y=0
  sta credits_screen+$0002 ; x=2 y=0
  sta credits_screen+$0003 ; x=3 y=0
  sta credits_screen+$0004 ; x=4 y=0
  sta credits_screen+$0005 ; x=5 y=0
  sta credits_screen+$00CD ; x=5 y=5
  sta credits_screen+$00A6 ; x=6 y=4
  sta credits_screen+$007E ; x=6 y=3
  sta credits_screen+$007F ; x=7 y=3
  sta credits_screen+$0057 ; x=7 y=2
  sta credits_screen+$0056 ; x=6 y=2
  sta credits_screen+$002E ; x=6 y=1
  sta credits_screen+$002D ; x=5 y=1
  sta credits_screen+$0055 ; x=5 y=2
  sta credits_screen+$007D ; x=5 y=3
  sta credits_screen+$00A5 ; x=5 y=4
  sta credits_screen+$00A2 ; x=2 y=4
  sta credits_screen+$007A ; x=2 y=3
  sta credits_screen+$0052 ; x=2 y=2
  sta credits_screen+$0051 ; x=1 y=2
  sta credits_screen+$0029 ; x=1 y=1
  sta credits_screen+$002A ; x=2 y=1
  sta credits_screen+$002B ; x=3 y=1
  sta credits_screen+$002C ; x=4 y=1
  sta credits_screen+$0054 ; x=4 y=2
  sta credits_screen+$0053 ; x=3 y=2
  sta credits_screen+$002F ; x=7 y=1
  
  inx
  lda .color_table,x  
  sta credits_screen+$007b ; x=3 y=3
  sta credits_screen+$007c ; x=4 y=3
  
  inx
  lda .color_table,x  
  sta credits_screen+$0194 ; x=4 y=10   
  sta credits_screen+$0195 ; x=5 y=10 
  sta credits_screen+$016D ; x=5 y=9  
  sta credits_screen+$0146 ; x=6 y=8  
  sta credits_screen+$011E ; x=6 y=7  
  sta credits_screen+$011F ; x=7 y=7  
  sta credits_screen+$00F6 ; x=6 y=6  
  sta credits_screen+$00F7 ; x=7 y=6  
  sta credits_screen+$00CF ; x=7 y=5  
  sta credits_screen+$00CE ; x=6 y=5    
  
  inx 
  lda .color_table,x  
  sta credits_screen+$016e ; x=6 y=9
  sta credits_screen+$00D0 ; x=8 y=5
  
  inx
  lda .color_table,x    
  sta animate_color1

  inx
  lda .color_table,x    
  sta animate_color2
  
  ;inx
  ;lda .color_table,x    
  ;sta animate_color3  

  rts  

.slowdown
  !byte $01
  
rotate_hires_press_space:
  dec .slowdown
  bne +
  lda #$03
  sta .slowdown
  
  ldy credits_screen+$03a8+6
  ldx #$06
-
  lda credits_screen+$03a8-1,x
  sta credits_screen+$03a8,x
  sta credits_screen+$03d0,x
  dex
  bne -
  
  sty credits_screen+$03a8
  sty credits_screen+$03d0
+  
  rts  
;  dec .slowdown
;  bne +
;  lda #$03
;  sta .slowdown
;  
;  ldy credits_screen+$03a8
;  ldx #$00
;-
;  lda credits_screen+$03a8+1,x
;  sta credits_screen+$03a8,x
;  sta credits_screen+$03d0,x
;  inx
;  cpx #$06
;  bne -
;  
;  sty credits_screen+$03a8+6
;  sty credits_screen+$03d0+6
;+  
;  rts  