;BANK
;$DD00 = %xxxxxx11 -> bank0: $0000-$3fff
;$DD00 = %xxxxxx10 -> bank1: $4000-$7fff
;$DD00 = %xxxxxx01 -> bank2: $8000-$bfff
;$DD00 = %xxxxxx00 -> bank3: $c000-$ffff

;CHARMEM
;$D018 = %xxxx000x -> charmem is at $0000
;$D018 = %xxxx001x -> charmem is at $0800
;$D018 = %xxxx010x -> charmem is at $1000
;$D018 = %xxxx011x -> charmem is at $1800
;$D018 = %xxxx100x -> charmem is at $2000
;$D018 = %xxxx101x -> charmem is at $2800
;$D018 = %xxxx110x -> charmem is at $3000
;$D018 = %xxxx111x -> charmem is at $3800

;SCREENMEM
;$D018 = %0000xxxx -> screenmem is at $0000
;$D018 = %0001xxxx -> screenmem is at $0400
;$D018 = %0010xxxx -> screenmem is at $0800
;$D018 = %0011xxxx -> screenmem is at $0c00
;$D018 = %0100xxxx -> screenmem is at $1000
;$D018 = %0101xxxx -> screenmem is at $1400
;$D018 = %0110xxxx -> screenmem is at $1800
;$D018 = %0111xxxx -> screenmem is at $1c00
;$D018 = %1000xxxx -> screenmem is at $2000
;$D018 = %1001xxxx -> screenmem is at $2400
;$D018 = %1010xxxx -> screenmem is at $2800
;$D018 = %1011xxxx -> screenmem is at $2c00
;$D018 = %1100xxxx -> screenmem is at $3000
;$D018 = %1101xxxx -> screenmem is at $3400
;$D018 = %1110xxxx -> screenmem is at $3800
;$D018 = %1111xxxx -> screenmem is at $3c00
  
!zone water
  
show_water
  ;jsr wait_border
  
  lda #%00000000
  sta $d015            ;VIC_SPRITE_SWITCH
  
  lda #%00000001       ; Move the VIC 16K block bank1: $8000-$bfff
  sta $dd00
  
  lda #$1b             ; textmode
  sta $d011

  lda #$18             ; activate Multicolor-Textmode 
  sta $d016
      
  lda #%10000000       ; charmem is at $0000 screenmem is at $2000
  sta $d018

  ;lda #$00
  ;sta $d020
  ;lda #$0b 
  ;sta $d021
  ;lda #$0f 
  ;sta $d022
  ;lda #$01 
  ;sta $d023
 
;copy screencolor
;  ldx #$b0
;--
;  lda #$09
;  sta SCREEN_COLOR+(0*$b0)-1,x
;  sta SCREEN_COLOR+(1*$b0)-1,x
;  lda #$0b
;  sta SCREEN_COLOR+16+(2*$b0)-1,x
;  sta SCREEN_COLOR+16+(3*$b0)-1,x
;  dex
;  bne --  
;  rts
;  ldx #$a0
;--
;  lda #$09
;  sta SCREEN_COLOR+(0*$a0)-1,x
;  sta SCREEN_COLOR+(1*$a0)-1,x
;  lda #$0b
;  sta SCREEN_COLOR+40*10+(0*$a0)-1,x
;  sta SCREEN_COLOR+40*10+(1*$a0)-1,x
;  dex
;  bne --  
  rts
  
flip_logo:
  ldx #$a0
--
  lda screendata+(0*$a0)-1,x
  tay
  
  lda screendata+40*10+(0*$a0)-1,x
  sta screendata+(0*$a0)-1,x

  tya
  sta screendata+40*10+(0*$a0)-1,x
  
;second half
  lda screendata+(1*$a0)-1,x
  tay
  
  lda screendata+40*10+(1*$a0)-1,x
  sta screendata+(1*$a0)-1,x

  tya
  sta screendata+40*10+(1*$a0)-1,x

;colormem
  lda #$09
  sta SCREEN_COLOR+(0*$a0)-1,x
  sta SCREEN_COLOR+(1*$a0)-1,x
  lda #$0b
  sta SCREEN_COLOR+40*10+(0*$a0)-1,x
  sta SCREEN_COLOR+40*10+(1*$a0)-1,x
  
  dex
  bne --  
  rts
  
current_sinus_position;
!byte $00

animate_water:
;------------
  dec current_sinus_position
  clc
  ldx current_sinus_position
!for row = 1 To 56
  lda sinus_table,x
  adc #%11010000
  tay
  jsr waitstable
  nop
  nop
  nop
  nop
  sty $d016
  dex
!end  

;------------
  rts
  
!align 255,0
sinus_table:
!byte 3,3,2,2,1,1,1,1,1,1,1,2,2,3,3,3
!byte 4,4,4,4,4,4,3,3,3,2,2,1,1,1,0,0
!byte 0,0,0,0,1,1,1,2,2,3,3,3,3,3,3,3
!byte 3,2,2,1,1,0,0,0,0,0,0,0,0,0,1,1
!byte 1,2,2,3,3,3,3,3,3,3,2,2,2,1,1,0
!byte 0,0,0,0,0,0,0,1,1,1,2,2,3,3,3,3
!byte 4,3,3,3,3,2,2,2,1,1,1,1,0,1,1,1
!byte 1,2,2,3,3,3,4,4,4,4,4,4,4,4,4,3
!byte 3,2,2,2,2,2,2,2,2,2,3,3,3,4,4,5
!byte 5,5,5,6,5,5,5,5,4,4,4,3,3,3,3,2
!byte 3,3,3,3,4,4,5,5,5,6,6,6,6,6,6,6
!byte 6,5,5,4,4,4,3,3,3,3,3,3,3,4,4,5
!byte 5,5,6,6,6,6,6,6,6,6,6,5,5,4,4,3
!byte 3,3,3,3,3,3,3,4,4,5,5,5,6,6,6,6
!byte 6,6,5,5,5,4,4,3,3,3,2,2,2,2,2,2
!byte 3,3,3,4,4,5,5,5,5,5,5,5,4,4,3,3

;!byte 3,2,2,1,1,1,0,0,0,0,0,0,1,1,1,2
;!byte 2,2,2,3,3,3,3,3,3,2,2,2,2,2,1,1
;!byte 1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2
;!byte 2,2,2,2,2,2,2,2,2,2,2,3,3,3,4,4
;!byte 4,4,5,5,5,5,5,4,4,4,3,3,2,2,1,1
;!byte 0,0,0,0,0,0,0,1,1,1,2,2,2,3,3,3
;!byte 3,3,3,3,3,3,2,2,2,1,1,1,0,0,0,0
;!byte 0,0,1,1,1,1,2,2,2,2,3,3,3,3,3,3
;!byte 3,3,3,3,3,3,4,4,4,4,5,5,5,5,6,6
;!byte 6,6,6,6,5,5,5,4,4,4,3,3,3,3,3,3
;!byte 3,3,3,4,4,4,5,5,5,6,6,6,6,6,6,6
;!byte 5,5,4,4,3,3,2,2,2,1,1,1,1,1,2,2
;!byte 2,2,3,3,3,4,4,4,4,4,4,4,4,4,4,4
;!byte 4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5
;!byte 5,5,4,4,4,4,4,3,3,3,3,3,3,4,4,4
;!byte 4,5,5,5,6,6,6,6,6,6,5,5,5,4,4,3